/* Copyright 2013-2017 Rene Widera, Benjamin Worpitz, Alexander Debus
 *
 * This file is part of libPMacc.
 *
 * libPMacc is free software: you can redistribute it and/or modify
 * it under the terms of either the GNU General Public License or
 * the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * libPMacc is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License and the GNU Lesser General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License
 * and the GNU Lesser General Public License along with libPMacc.
 * If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include "pmacc_types.hpp"

#include "algorithms/math/defines/abs.hpp"
#include "algorithms/math/defines/sqrt.hpp"
#include "algorithms/math/defines/exp.hpp"
#include "algorithms/math/defines/erf.hpp"
#include "algorithms/math/defines/trigo.hpp"
#include "algorithms/math/defines/cross.hpp"
#include "algorithms/math/defines/dot.hpp"
#include "algorithms/math/defines/comparison.hpp"
#include "algorithms/math/defines/floatingPoint.hpp"
#include "algorithms/math/defines/pow.hpp"
#include "algorithms/math/defines/modf.hpp"
#include "algorithms/math/defines/fmod.hpp"

#include "algorithms/math/floatMath/abs.tpp"
#include "algorithms/math/floatMath/sqrt.tpp"
#include "algorithms/math/floatMath/exp.tpp"
#include "algorithms/math/floatMath/erf.tpp"
#include "algorithms/math/floatMath/trigo.tpp"
#include "algorithms/math/floatMath/comparison.tpp"
#include "algorithms/math/floatMath/floatingPoint.tpp"
#include "algorithms/math/floatMath/pow.tpp"
#include "algorithms/math/floatMath/modf.tpp"
#include "algorithms/math/floatMath/fmod.tpp"

#include "algorithms/math/doubleMath/abs.tpp"
#include "algorithms/math/doubleMath/sqrt.tpp"
#include "algorithms/math/doubleMath/exp.tpp"
#include "algorithms/math/doubleMath/erf.tpp"
#include "algorithms/math/doubleMath/trigo.tpp"
#include "algorithms/math/doubleMath/comparison.tpp"
#include "algorithms/math/doubleMath/floatingPoint.tpp"
#include "algorithms/math/doubleMath/pow.tpp"
#include "algorithms/math/doubleMath/modf.tpp"
#include "algorithms/math/doubleMath/fmod.tpp"

